package test.remoteinvocation.services;

import java.time.OffsetDateTime;
import javax.annotation.PostConstruct;
import javax.annotation.PreDestroy;
import javax.enterprise.context.RequestScoped;

@RequestScoped
public class TimeService {

    private boolean disposed;
    private String time;

    public String getTime() {
        if (disposed) {
            throw new RuntimeException("already disposed");
        }

        return time;
    }

    @PostConstruct
    private void initialize() {
        time = OffsetDateTime.now().toString();
        disposed = false;
        System.out.println("initialized");
    }

    @PreDestroy
    private void dispose() {
        disposed = true;
        System.out.println("disposed");
    }
}
