package tds.dimatestproject.controller.main;

import java.io.IOException;
import java.util.Properties;
import javax.enterprise.context.ApplicationScoped;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;
import test.remoteinvocation.contracts.Service;

@ApplicationScoped
public class ServiceProvider {

    private final InitialContext context;

    public ServiceProvider() throws NamingException, IOException {
        context = new InitialContext();
    }

    private <T> T get(String module, String bean, Class<T> contract) throws NamingException {
        final String application = "ServiceEAR";
        final String distinct = "";

        final String name = contract.getName();

        T service = (T) context.lookup("ejb:" + application + "/" + module + "/" + distinct + "/" + bean + "!" + name);
        return service;
    }

    public Service getService() throws NamingException {
        return get("Services", "HelloService", Service.class);
    }
}
